#==============================================================================
#     (c) Copyright 2006, Hewlett-Packard, all rights reserved.
#
#     PACKAGE      HP OpenView OmniBack II
#     FILE         DPvmware_vmfs-umount.sh
#     RCS          $Header: /src/util/VMWareESX/DPvmware_vmfs-umount.sh /main/dp60_fix/1 2008-05-13 18:05:56 palos $
#
#==============================================================================


DF_OUTPUT="/tmp/df.tmp"
VMFS_TO_UMOUNT="/tmp/vmfs_to_umount.tmp"

if [ -s $VMFS_TO_UMOUNT ]; then
    rm $VMFS_TO_UMOUNT
fi

echo
echo "Unmounting the VMFS file systems mounted for Data Protector purposes"
echo "=================================="

echo
/bin/df
echo "=================================="

/bin/df | grep vmhba > ${DF_OUTPUT} 2> /dev/null
`awk '{ print $1 "@" $6 }' $DF_OUTPUT > $VMFS_TO_UMOUNT`
rm $DF_OUTPUT

if [ -s $VMFS_TO_UMOUNT ]; then
    cat $VMFS_TO_UMOUNT
    echo "=================================="
    for LINE in `awk '{ if (NF == 1) print $1 }' $VMFS_TO_UMOUNT 2> /dev/null`
    do
        FILESYSTEM=`echo $LINE|cut -f1 -d@`
        MOUNTPOINT=`echo $LINE|cut -f2 -d@`
        echo "Unmounting $FILESYSTEM from $MOUNTPOINT"
        /bin/umount ${MOUNTPOINT}
        echo "=================================="
    done
fi

echo
/bin/df
echo "=================================="